<script setup>
import { ref, onMounted, watch } from 'vue'
import EasyMDE from 'easymde'

// 各入力値は親側で使いたいため、コンポーネントの v-model で双方向バインド
// 参考 : https://ja.vuejs.org/guide/components/v-model.html
const props = defineProps({
  id: String,
  text: String,
  tag: String
})
const emit = defineEmits(['update:text', 'update:tag'])

let easyMDE = null

// EasyMDE はマウント後にしか使えない
onMounted(() => {
  easyMDE = new EasyMDE({
    element: document.getElementById(props.id),
    maxHeight: '10vh',
    spellChecker: false,
    nativeSpellcheck: false,
    status: false
  })
  easyMDE.codemirror.on("change", () => {
    emit('update:text', easyMDE.value())
  })

  easyMDE.value(props.text)
})

// 親側の変更を直接 EasyMDE とバインドできなさそうなため、監視して反映
watch(props, () => {
  if (props.text != easyMDE.value()){
    easyMDE.value(props.text)
  }
})
</script>

<template>
  <div class="row">
    <div class="col-10">
      <textarea
        :id="id"
        placeholder="enter the memo"
      />
    </div>
    <div class="col-2">
      <input 
        :value="tag"
        @input="$emit('update:tag', $event.target.value)"
        placeholder="enter the tag"
      />
    </div>
  </div>
</template>

<style scoped>

</style>

